Attribute VB_Name = "ini"
Option Explicit
Global RootDir As String
Global IndexFile As String
Global ErrFile As String
Global FileType As String
Global LogFile As String
Global PathToPerl As String
Global PathToPhp As String
Global Cmd As String
Global Port As Integer
Global CUsers As Integer
Global tb&
Global StartTime As String
Global cdir
Global ocdir
Global cp
Global shouldstart
Global RequestedDir
#If Win16 Then


Declare Function WritePrivateProfileString Lib "Kernel" (ByVal AppName As String, ByVal KeyName As String, ByVal NewString As String, ByVal filename As String) As Integer


Declare Function GetPrivateProfileString Lib "Kernel" Alias "GetPrivateProfilestring" (ByVal AppName As String, ByVal KeyName As Any, ByVal default As String, ByVal ReturnedString As String, ByVal MAXSIZE As Integer, ByVal filename As String) As Integer
#Else

Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long


Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
#End If
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDriectory As Long, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
    End Type
Private Type STARTUPINFO
    cb As Long
    lpReserved As Long
    lpDesktop As Long
    lpTitle As Long
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
    End Type
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Public Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, Optional ByVal lpszShortPath As String, Optional ByVal cchBuffer As Long) As Long
Public Function GetShortFilename(ByVal sLongFilename As String) As String
    Dim lRet As Long
    Dim sShortFilename As String

    sShortFilename = String$(1024, " ")
    lRet = GetShortPathName(sLongFilename, sShortFilename, Len(sShortFilename))
    
 

    If lRet > Len(sShortFilename) Then
        
        sShortFilename = String$(lRet + 1, " ")
        
        lRet = GetShortPathName(sLongFilename, sShortFilename, Len(sShortFilename))
    End If
    
   
    If lRet > 0 Then
        GetShortFilename = Left$(sShortFilename, lRet)
    End If
    
End Function

Function ShellAndWait(strCommandLine As String, lWait As Long) As Long
    Dim objProcess As PROCESS_INFORMATION
    Dim objStartup As STARTUPINFO
    Dim lResult As Long
    Dim lExitCode As Long
    objStartup.cb = 68
    objStartup.lpReserved = 0
    objStartup.lpDesktop = 0
    objStartup.lpTitle = 0
    objStartup.dwX = 0
    objStartup.dwY = 0
    objStartup.dwXSize = 0
    objStartup.dwYSize = 0
    objStartup.dwXCountChars = 0
    objStartup.dwYCountChars = 0
    objStartup.dwFillAttribute = 0
    objStartup.dwFlags = 0
    objStartup.wShowWindow = 0
    objStartup.cbReserved2 = 0
    objStartup.lpReserved2 = 0
    objStartup.hStdInput = 0
    objStartup.hStdOutput = 0
    objStartup.hStdError = 0
    
    
    lResult = CreateProcess(0, strCommandLine, 0, 0, 0, 0, 0, 0, objStartup, objProcess)

    If lResult = 0 Then
        ShellAndWait = -1
        Exit Function
    End If
    If lWait <> 0 Then
        lResult = WaitForSingleObject(objProcess.hProcess, lWait)


        If lResult = 258 Then
            lResult = TerminateProcess(objProcess.hProcess, -1)
            lResult = WaitForSingleObject(objProcess.hProcess, lWait)
        End If
    End If
    
    
    lResult = GetExitCodeProcess(objProcess.hProcess, lExitCode)
    lResult = CloseHandle(objProcess.hProcess)
    lResult = CloseHandle(objProcess.hThread)
    
    ShellAndWait = lExitCode
End Function



Function ReadINI(Section, KeyName, filename As String) As String
    Dim sRet As String
    sRet = String(255, Chr(0))
    ReadINI = Left(sRet, GetPrivateProfileString(Section, ByVal KeyName, "", sRet, Len(sRet), filename))
End Function

Function writeini(sSection As String, sKeyName As String, sNewString As String, sFileName) As Integer
    Dim r
    r = WritePrivateProfileString(sSection, sKeyName, sNewString, sFileName)
End Function

